\chapter{File I/O}

\section{Storing ROOT Objects}
ROOT offers the possibility to write the instances of all the classes 
inheriting from the class \verb|TObject| (basically all classes in ROOT) 
on disk, into what is referred to as 
\textit{ROOT-file}, a file created by the \verb|TFile| class. 
One says that the object is made ``persistent'' by storing it on disk.
When reading the file back, the object can be restored to memory.

We can explore this functionality with histograms and two simple macros.
%
\lstinputlisting{macros/write_to_file.cxx}
\vspace{-.5pc} \hfill\small file: \texttt{write\_to\_file.cxx}\\~\\
% 
The \textit{RECREATE} option forces ROOT to create a new file even if 
a file with the same name exists on disk.

Now, you may use the CINT command line to access information in the 
file and draw the previously written histogram:
\begin{lstlisting}
>>>  root my_rootfile.root
root [0]
Attaching file my_rootfile.root as _file0...
root [1] _file0.ls()
TFile**         my_rootfile.root
 TFile*         my_rootfile.root
  KEY: TH1F     my_histogram;1  My Title
root [2] my_histogram.Draw()
\end{lstlisting}
Alternatively, you can use a simple macro to carry out the job:
%
\lstinputlisting{macros/read_from_file.cxx}
\vspace{-.5pc} \hfill\small file: \texttt{read\_from\_file.cxx}\\~\\
%
Please note that the order of opening files for write access and creating 
objects determines whether the objects are stored or not. You can avoid this 
behaviour by using the \verb|Write()| function as shown in the previous example.

Although you could access an object within a file also with the \verb|Get| 
function and a dynamic type cast, it is advisable to use
 \verb|GetObjectChecked|.

\section{N-tuples in ROOT}

\subsection{Storing simple N-tuples}
Up to now we have seen how to manipulate input read from ASCII files.
ROOT offers the possibility to do much better than that, with its own 
n-tuple classes.
Among the many advantages provided by these classes one could cite
\begin{itemize} 
 \item Optimised disk I/O.
 \item Possibility to store many n-tuple rows (Millions). 
 \item Write the n-tuples in ROOT files.
 \item Interactive inspection with \verb|TBrowser|.
 \item Store not only numbers, but also \textit{objects} in the columns.
\end{itemize}

In this section we will discuss briefly the \verb|TNtuple| class, which is 
a simplified version of the \verb|TTree| class.
A ROOT \verb|TNtuple| object can store rows of float entries. 
Let's tackle the problem according to the usual strategy commenting a 
minimal example
%
\lstinputlisting{macros/write_ntuple_to_file.cxx}
\vspace{-.5pc} \hfill{\small file: \texttt{write\_ntuple\_to\_file.cxx}\\~\\
%
This data written to this example n-tuple represents, in the statistical 
sense, three independent variables (Potential or Voltage, Pressure and
Temperature), and one variable (Current) which depends on the the
others according to very simple laws, and an additional Gaussian
smearing. 
This set of variables mimics a measurement of an electrical resistance 
while varying pressure and temperature. 

Imagine your task now consists in finding the relations
among the variables -- of course without knowing the code used to generate
them. 
You will see that the possibilities of the \verb|NTuple| class enable you
to perform this analysis task. Open the ROOT file (\verb|cond_data.root|) 
written by the macro above in an interactive section and use a 
\verb|TBrowser| 
to interactively inspect it: \vskip -1pc
\begin{lstlisting}
root[0] new TBrowser()
\end{lstlisting}

You find the columns of your n-tuple written 
as \textit{leafs}. Simply clicking on them you can obtain histograms
of the variables!

Next, try the following commands at the shell prompt and in the 
interactive ROOT shell, respectively: 
\vskip -1pc \begin{lstlisting} 
> root conductivity_experiment.root
Attaching file conductivity_experiment.root as _file0...
root [0] cond_data.Draw("Current:Potential")
\end{lstlisting}
You just produced a correlation plot with one single line of code!

Try to extend the syntax typing for example
\vskip -1pc \begin{lstlisting}
root [1] cond_data.Draw("Current:Potential","Temperature<270")
\end{lstlisting}
What do you obtain? 

Now try 
\vskip -1pc \begin{lstlisting}
root [2] cond_data.Draw("Current/Potential:Temperature")
\end{lstlisting}
It should have become clear from these examples how to navigate in such 
a multi-dimensional space of variables and uncover relations between 
variables using n-tuples.

\subsection{Reading N-tuples}

For completeness, you find here a small macro to read the data back from 
a ROOT n-tuple
%
\lstinputlisting{macros/read_ntuple_from_file.cxx}
\vspace{-.5pc} \hfill\small file: \texttt{read\_ntuple\_from\_file.cxx}\\~\\
%
The macro shows the easiest way of accessing the content of a n-tuple: after loading the n-tuple, its branches are assigned to variables and \verb|GetEntry(long)| automatically fills them with the content for a specific row. By doing so, the logic for reading the n-tuple and the code to process it can be split and the source code remains clear.


\subsection{Storing Arbitrary N-tuples}\label{sec:storing_arbitrary_ntuples}
It is also possible to write n-tuples of arbitrary type by using ROOT's
\verb|TBranch| class. This is especially important as \verb|TNtuple::Fill()| 
accepts only floats. The following macro creates the ame n-tuple as before 
but the branches are booked directly. The \verb|Fill()| function then fills 
the current values of the connected variables to the tree.
%
\lstinputlisting{macros/write_ntuple_to_file_advanced.cxx}
\vspace{-.5pc} \hfill\small file: \texttt{write\_ntuple\_to\_file\_advanced.cxx}\\~\\
%

The \verb|Branch()| function requires a pointer to a variable and a definition
of the variable type. Table \ref{tab:ttree_variable_types} lists some of the 
possible values. Please note that ROOT is not checking the input and mistakes 
are likely to result in serious problems. This holds especially if values are 
read as another type than they have been written, e.g. when storing a variable 
as float and reading it as double.

\begin{table}[htbp]
	\centering
	\caption{List of variable types that can be used to define the type of a branch in ROOT.}
	\begin{tabular}{lclc}
	\\\toprule
	type                               & size    & C++     & identifier \\
	\midrule
	\multirow{2}{*}{signed integer}    & 32 bit  & int 	      & I\\
					   & 64 bit  & long 	      & L\\
	\multirow{2}{*}{unsigned integer}  & 32 bit  & unsigned int   & i\\
					   & 64 bit  & unsigned long  & l\\
	\multirow{2}{*}{floating point}	   & 32 bit  & float	      & F\\
					   & 64 bit  & double	      & D\\
	boolean				   & -	     & bool	      & O\\
	\bottomrule
	\end{tabular}
	\label{tab:ttree_variable_types}
\end{table}


\subsection{Processing N-tuples Spanning over Several Files}

Usually n-tuples or trees span over many files and it would be difficult to
add them manually. ROOT thus kindly provides a helper class in the form of 
\verb|TChain|. Its usage is shown in the following macro which is very similar 
to the previous example. The constructor of a \verb|TChain| takes the name of 
the \verb|TTree| (or \verb|TNuple|) as an argument. The files are added with 
the function \verb|Add(fileName)|, where one 
can also use wild-cards as shown in the example.
%
\lstinputlisting{macros/read_ntuple_with_chain.cxx}
\vspace{-.5pc} \hfill\small file: \texttt{read\_ntuple\_with\_chain.cxx}\\~\\
%

\subsection{{\em For the advanced user:}  Processing trees with a selector script}

Another very general and powerful way of processing a \verb|TChain| is 
provided via the method \verb|TChain::Process()|. This method takes as 
arguments an instance of a -- user-implemented-- class of type 
\verb|TSelector|, and -- optionally -- the number of entries and the first 
entry to be processed. A template for the
class \verb|TSelector| is provided by the method \verb|TTree::MakeSelector|, 
as is shown in the little macro \verb|makeSelector.C| below. 

It opens the n-tuple 
\verb|conductivity_experiment.root| from the example above and creates from it 
the header file
\verb|MySelector.h| and a template to insert your own analysis code,
\verb|MySelector.C|. 

%
\lstinputlisting{macros/makeMySelector.C}
\vspace{-.5pc} \hfill\small file: \texttt{makeMySelector.C}\\
%
The template contains the entry points 
\verb|Begin()| and 
\verb|SlaveBegin()| called before processing of the \verb|TChain| starts, 
\verb|Process()| called for every entry of the chain, and
\verb|SlaveTerminate()| and \verb|Terminate()| called after the last
entry has been processed. Typically, initialization like booking of histograms
is performed in \verb|SlaveBegin()|, the analysis, i.\,e. the
selection of entries, calculations and filling of histograms, is done in  
\verb|Process()|, and final operations like plotting and storing of 
results happen in \verb|SlaveTerminate()| or \verb|Terminate()|.

The entry points \verb|SlaveBegin()| and \verb|SlaveTerminate()| are called on 
so-called slave nodes only if parallel processing via \verb|PROOF| or 
\verb|PROOF lite| is enabled, as will be explained below.  

A simple example of a selector class is shown in the macro \verb|MySelector.C|.
The example is executed with the following sequence of commands:
\begin{lstlisting} 
> TChain *ch=new TChain("cond_data", "My Chain for Example N-Tuple");
> ch->Add("conductivity_experiment*.root");
> ch->Process("MySelector.C+"); 
\end{lstlisting} 
%
As usual, the ``\verb|+|'' appended to the name of the macro to be executed
initiates the compilation of the \verb|MySelector.C| with the system compiler
in order to improve performance.

The code in \verb|MySelector.C|, shown in the listing below, books some histograms in \verb|SlaveBegin()| and adds them to the instance \verb|fOutput|, which is of the class \verb|TList|\footnote{The usage of \texttt{fOutput} is not really needed for this simple example, but it allows re-usage of the exact code in parallel processing with \texttt{PROOF} (see next section).} The final processing in \verb|Terminate()| allows to access histograms and store,
display or save them as pictures. This is shown in the example via the \verb|TList| 
\verb|fOutput|. See the commented listing below for more details; most of the text is actually 
comments generated automatically by \verb|TTree::MakeSelector|. 
%
\lstinputlisting{macros/MySelector.C}
\vspace{-.5pc} \hfill\small file: \texttt{MySelector.C}\\
%
\subsection{{\em For power-users:}  Multi-core processing with \texttt{PROOF lite}}
The processing of n-tuples via a selector function of type \verb|TSelector|
through \verb|TChain::Process()|, as described at the end of the previous
section, offers an additional advantage in particular for very large
data sets: on distributed systems or multi-core architectures, portions
of data can be processed in parallel, thus significantly reducing the execution
time. On modern computers with multi-core CPUs or hyper-threading
enabled, this allows a much faster turnaround of analyses, since all the
available CPU power is used. 

On distributed systems, a PROOF server and worker nodes have to be set up, as is 
described in detail in the ROOT documentation. On a single computer with multiple
cores, \verb|PROOF lite| can be used instead. Try the following little macro,
\verb|RunMySelector.C|, which contains two extra lines compared to 
the example above (adjust the number of workers according to the number of CPU cores):
%
\lstinputlisting{macros/RunMySelector.C}
\vspace{-.5pc} \hfill\small file: \texttt{RunMySelector.C}\\
%
The first command, \verb|TProof::Open()| starts a local PROOF server, and the
command \verb|ch->SetProof();| enables processing of the chain using PROOF.
Now, when issuing the command \verb|ch->Process("MySelector.C+);|, the
code in \verb|MySelector.C| is compiled and executed on each slave node. 
The methods \verb|Begin()| and \verb|Terminate()| are executed on 
the master only.
The list of n-tuple files is analysed, and portions of the data are assigned
to the available slave processes. Histograms booked in \verb|SlaveBegin()|
exist in the processes on the slave nodes, and are filled accordingly. Upon
termination, the PROOF master collects the histograms from the slaves and 
merges them. In \verb|Terminate()| all merged histograms are available and 
can be inspected, analysed or stored.
The histograms are handled via the instances \verb|fOutput| of class 
\verb|TList| in each slave process, and can be retrieved from this
list after merging in \verb|Terminate|. 

To explore the power of this mechanism, generate some very large n-tuples
using the script from Section~\ref{sec:storing_arbitrary_ntuples} - you could try 10\,000\,000 events (this results in a large n-tuple of
about 160 MByte in size). You could also generate a large number of
files and use wildcards to add the to the \verb|TCHain|. Now execute \\
\verb|> root -l RunMySelector.C| \\
and watch what happens: 
\begin{lstlisting} 
Processing RunMySelector.C...
 +++ Starting PROOF-Lite with 4 workers +++
Opening connections to workers: OK (4 workers)                 
Setting up worker servers: OK (4 workers)                 
PROOF set to parallel mode (4 workers)
 
Info in <TProofLite::SetQueryRunning>: starting query: 1
Info in <TProofQueryResult::SetRunning>: nwrks: 4
Info in <TUnixSystem::ACLiC>: creating shared library ~/DivingROOT/macros/MySelector_C.so
*==* ---------- Begin of Job ---------- Date/Time = Wed Feb 15 23:00:04 2012
Looking up for exact location of files: OK (4 files)                 
Looking up for exact location of files: OK (4 files)                 
Info in <TPacketizerAdaptive::TPacketizerAdaptive>: Setting max number of workers per node to 4
Validating files: OK (4 files)                 
Info in <TPacketizerAdaptive::InitStats>: fraction of remote files 1.000000
Info in <TCanvas::Print>: file ResistanceDistribution.png has been created
*==* ---------- End of Job ---------- Date/Time = Wed Feb 15 23:00:08 2012
Lite-0: all output objects have been merged                                                    
\end{lstlisting} 

Log files of the whole processing chain are kept in the directory
\verb|~.proof| for each worker node. This is very helpful for debugging or if
something goes wrong. As the the method described here also works without
using PROOF, the development work on an analysis script can be done in the
standard way on a small subset of the data, and only for the full 
processing one would use parallelism via PROOF.

\subsection{Optimisation Regarding N-tuples}
ROOT automatically applies compression algorithms on n-tuples to reduce the memory consumption. A value that is in most cases only zero will consume only small space on your disk (but it has to be deflated on reading). Nevertheless, you should think about the design of your n-tuples and your analyses as soon as the processing time exceeds some minutes.

\begin{itemize}
	\item Try to keep your n-tuples simple and use appropriate variable types. If your measurement has only a limited precision, it is needless to store it with double precision.
	\item Experimental conditions that do not change with every single measurement should be stored in a separate tree. Although the compression can handle redundant values, the processing time increase with every variable that has to be filled.
	\item The function \verb|SetCacheSize(long)| specifies the size of the cache for reading a \verb|TTree| object from a file. The default value is 30MB. A manual increase may help in certain situations. Please note that the caching mechanism can cover only one \verb|TTree| object per \verb|TFile| object.
	\item You can select the branches to be covered by the caching algorithm with \verb|AddBranchToCache| and deactivate unneeded branches with \verb|SetBranchStatus|. This mechanism can result in a significant speed-up for simple operations on trees with many branches.
	\item You can measure the performance easily with \verb|TTreePerfStats|. The ROOT documentation on this class also includes an introductory example. For example, \verb|TTreePerfStats| can show you that it is beneficial to store meta data and payload data separately, i.\,e. write the meta data tree in a bulk to a file at the end of your job instead of writing both trees interleaved.
\end{itemize}
